/**
 * Victor Silva - University of Bridgeport 27 April 1997
 *
 * Computes and displays the histogram for each primary
 * color of an image that was previously read.
 */
package VS;

import java.awt.*;
import java.io.*;

public class vsHistogram extends Frame
{
   final int FRAME_WIDTH = 275;
   final int FRAME_HEIGHT = 150;
   Color drawColor;
   int numPixels;
   double[] histArray;

   public vsHistogram(short[] r, short[] g, short[] b, String title,
      int width, int height, Color intensity)   {
      super(title);
      resize(FRAME_WIDTH, FRAME_HEIGHT);
      setResizable(false);
      drawColor = intensity;

      histArray = new double[256];
      numPixels = width * height;

      // Count
      for(int i=0; i<numPixels; i++) {
         histArray[r[i] & 0xFF]++;
         histArray[g[i] & 0xFF]++;
         histArray[b[i] & 0xFF]++;
      }

      // Find max for normalizing
      double max = 0.0;
      for(int i=0; i<256; i++)  {
         if (histArray[i] > max)
            max = histArray[i];
      }

      // Normalize
      for(int i=0; i<256; i++) {
         histArray[i] = (histArray[i] / max) * 100.0;
      }

      show();
   }

   public vsHistogram(short[] plane, String title, int width, int height,
      Color histColor)
   {
      super(title);
      resize(FRAME_WIDTH, FRAME_HEIGHT);
      setResizable(false);
      drawColor = histColor;

      histArray = new double[256];
      numPixels = width * height;

      // Count
      for(int i=0; i<numPixels; i++)
      {
         histArray[plane[i] & 0xFF]++;
      }

      // Find max for normalizing
      double max = 0.0;
      for(int i=0; i<256; i++)
      {
         if (histArray[i] > max)
         {
            max = histArray[i];
         }
      }

      // Normalize
      for(int i=0; i<256; i++)
      {
         histArray[i] = (histArray[i] / max) * 100.0;
      }

      show();
   }

   public boolean handleEvent(Event event)
   {
      if (event.id == Event.WINDOW_DESTROY)
      {
         dispose();
         return(true);
      }

      return super.handleEvent(event);
   }

   public void paint(Graphics g)
   {

      for(int i=0; i<256; i++)
      {
         g.setColor(drawColor);
         g.drawLine(i+5, FRAME_HEIGHT-45, i+5, 
            (FRAME_HEIGHT - 45) - (int)histArray[i]);

         if (i%50 == 0)
         {
            g.setColor(Color.black);
            String s = String.valueOf(i);
            g.drawString(s, i, FRAME_HEIGHT-30);
         }
      }
   }
}