package futils;
import java.awt.*;
import java.io.*;
import java.util.*;


public class DirList  {
   String startDir; 
   private Vector history = new Vector();
   int totalBytes = 0;
   int totalFiles = 0;

   public static void main(String args[]) {
      DirList dl = new DirList();
      dl.print();
      dl.printStats();
   }

   DirList() {
      startDir = Ls.getDirName();
      startAtThisDir(startDir);
   }
   public File [] getFiles() {
   	File f[] = new File[history.size()];
   	for (int i=0; i < f.length; i++)
   		f[i] = (File)history.elementAt(i);
   	return f;
   }
   public void print() {
   	File f[] = getFiles();
   	for (int i=0; i < f.length; i++)
   		System.out.println(f[i]);
   	
   }
   
   public void printStats() {
   	System.out.println("Saw " +
      		totalFiles +
      		" files with a total size of " +
      		totalBytes  +
      		" bytes");
   }

   //-------------------------------------------------------
   // Recursive function that given an anchor directory
   // will walk directory tree 
   // 
   //-------------------------------------------------------
   public void startAtThisDir(String anchorDir)
   {
      FileFilter files = new FileFilter();
      DirFilter dirs = new DirFilter();
      File f1 = new File(anchorDir);
      File f2;
      FileInputStream fis;
      int i;
      String[] ls;
      int bytes;

      //-------------------------------------------------------
      // Loop through all the filenames in the current directory
      // and store them in history:
      //-------------------------------------------------------
      for (ls = f1.list(files), i=0; 
      		ls != null && i < ls.length; i++) {
      	totalFiles++;
      	f2 = new File(f1, ls[i]);
      	bytes = Futil.available(f2);
      	totalBytes +=  bytes;
        history.addElement(f2);
      }

      //-------------------------------------------------------
      // This loop recurses on all directory names in 
      // the current working directory.
      //-------------------------------------------------------
      for (ls = f1.list(dirs), 
      	i=0; ls != null && i < ls.length; i++)
         startAtThisDir(anchorDir + ls[i] + f1.separator);
   }

}



