package observers;
import java.awt.*;
import java.applet.*;
import java.io.*;

import gui.*;


public class DoubleDialog extends ClosableFrame {

	public Label label1;
	public DoubleTextField textfield;
	
	private static int offset = 10;

	Button okButton;
	Button cancelButton;
	
	 public ObservableDouble i;

	public DoubleDialog(
		String dialog_title, 
		String label,
		ObservableDouble sample) {
	 super(dialog_title);
	 init( dialog_title,  label);
	 set(sample);
	
	}

	public void set(ObservableDouble sample) {
		i = sample;
		
		textfield = new DoubleTextField(i);
		add("Right",textfield);
		textfield.reshape(89, 25, 64, 16);
		cancelButton = new Button("Cancel");
		add(cancelButton);
		cancelButton.reshape(13, 175, 88, 28);
	
		okButton = new Button("OK");
		add(okButton);
		okButton.reshape(130, 175, 63, 29);

		pack();
		show();
	}
    public void init(String dialog_title, String label) {
	setLayout(new FlowLayout());
	resize(250, 250);
	reshape(offset, offset, 
			250, 250);
	offset = offset + 15;

	setResizable(false);
	
	//Initialize components
	label1 = new Label(label);
	add("Left", label1);
	label1.reshape(5, 19, 86, 23);
    }

  private void ok() {
			// If the text is not a valid int then the dialog 
			// box will stay visible.
			System.out.println("OK!");
			String s = textfield.getText();

			Double i_dbl = new Double(i.getValue());
			 // default values
			try {
    			 i_dbl = Double.valueOf(s);
    			 i.setValue(i_dbl.doubleValue());
 				 
 			}
 			catch (NumberFormatException e)  {
 			  System.out.println(
 				"IntDialog:ER! Not a number, using defaults");
 				// pick a reasonable default
 			}
		return;
   }
  
  private void cancel() {
  	System.out.println("Cancel!");
  }
   
 public boolean handleEvent(Event event) {
 	if (Evt.match(event, 'o', okButton))
 		ok();
 
 	else if (Evt.match(event, 'k', cancelButton))
 		cancel();
 	return super.handleEvent(event);
 }
}
    


