package observers;
import java.awt.*;
import java.util.*;

//
// IntLabel - a Label that displays the value of
// an ObservableInt.
public class IntLabel extends Label implements Observer
{
     private ObservableInt intValue;     // The value we're observing
     public int getValue() {
     	return intValue.getValue();
     }
     
     public void setValue(int i) {
     	intValue.setValue(i);
     }
     public IntLabel(ObservableInt theInt)
     {
          intValue = theInt;
// Tell intValue we're interested in it
          intValue.addObserver(this);
// Initialize the label to the current value of intValue
          setText(""+intValue.getValue());
     }
// Update will be called whenever intValue is changed, so just update
// the label text.
     public void update(Observable obs, Object arg)
     {
          setText(""+intValue.getValue());
     }
}